Bug 209420 - NFS data corruption
NFS data corruption
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
All Linux
high Severity high
: ---
: ---
Assigned To: Steve Dickson
Brian Brock
Depends On:
Blocks: 210071
  Show dependency treegraph
Reported: 2006-10-05 06:55 EDT by David Howells
Modified: 2007-11-30 17:11 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-11-12 00:46:26 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Network trace of echo/od on warthog (4.31 KB, application/octet-stream)
2006-10-05 06:55 EDT, David Howells
no flags Details
Purposed Upstream Patch (1.02 KB, patch)
2006-10-09 17:41 EDT, Steve Dickson
no flags Details | Diff

  None (edit)
Description David Howells 2006-10-05 06:55:40 EDT
I'm seeing the ~/Mail/inbox/.mh_sequences file in my NFS mounted homedir 
acquiring extra NUL chars on the end.

I can reproduce this simply, using two client machines.  One of them (warthog, 
say) uses echo to create a file:

        echo hello >~/hello

Then a second machine (hades) extends it:

        echo hello >>~/hello

Then the first machine looks at it again:

        od -c <~/hello
        0000000   h   e   l   l   o  \n  \0  \0  \0  \0  \0  \0

Note that the file has been extended by as many NUL characters as were in the 
original write.  I suspect that it will cut off at a page boundary as NFS will 
be forced to go and fetch a new page at that point.

I've attached a wire trace of the first client (warthog) covering the echo/od 
sequence.  Note that though there's a write (packet 14) for the echo on 
warthog, there's no read to show that the data is being read back.  warthog 
knows the file is bigger - it learnt that in packet 21.
Comment 1 David Howells 2006-10-05 06:55:40 EDT
Created attachment 137810 [details]
Network trace of echo/od on warthog
Comment 2 Steve Dickson 2006-10-09 17:41:49 EDT
Created attachment 138084 [details]
Purposed Upstream Patch
Comment 3 David Howells 2006-10-11 10:38:24 EDT
This appears to be fixed in 2.6.18-1.2759.fc6.
Comment 4 Piete Brooks 2006-10-12 01:43:59 EDT
2.6.18-1.2759.fc6 also fixes 209977. Thanks!

teith:~: echo CBA>tmp/n;od -c tmp/n;ssh -n -x greta echo X\>tmp/n;od -c tmp/n
0000000   C   B   A  \n
0000000   X  \n
teith:~: uname -a
Linux teith.cl.cam.ac.uk 2.6.18-1.2759.fc6 #1 SMP Tue Oct 10 17:34:23 EDT 2006
x86_64 x86_64 x86_64 GNU/Linux
Comment 5 Dave Jones 2006-11-12 00:46:26 EST
should be fixed in 2.6.18-1.2849.fc6 now in updates

Note You need to log in before you can comment on or make changes to this bug.